#include <bits/stdc++.h>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;

    cin>>t;
    int n,k;
    cin>>n>>k;
    int n1=0;
    int p=0;
    vector<int>v(n);

    for(int i=0;i<n;i++){
       cin>>v[i];
       if(v[i]==-1){
        n1++;
       }
       else if(v[i]==1){
        p++;
       }
}
sort(v.begin(),v.end());
if(n1+p==n){
    if(k>2 & k<-2){
        cout<<"NE"<<endl;
        return 0;
    }

}


int kp=0;
    for(int i=0;i<n;i++){
        if(kp<=v[i]){
            kp++;
        }
        else{
            kp--;
        }
    }
    if(kp==k){
        cout<<"DA"<<endl;
        if(t==1){
        for(int i=0;i<n;i++){
            cout<<v[i]<<endl;
        }}
    }
    else{cout<<"NE"<<endl;}

}